------------------------------------------------------------------------
-- @class CloudLayer
-- Class representing a cloud layer in the sky
------------------------------------------------------------------------


class "CloudLayer"{
}


function CloudLayer:__init__()
    self.pos    =   {x=0, y=0}
    self.speed  =   10
    self.image  =   nil
end


function CloudLayer:setImage(p_image)
    assert(p_image, "Cloud layer needs an image")
    self.image  =   p_image

end

function CloudLayer:update(dt)
    self.pos.x  =   self.pos.x + dt * self.speed
end


function CloudLayer:draw()
    love.graphics.draw(self.image, self.pos.x, self.pos.y)

end
