------------------------------------------------------------------------
-- @class Nutriment
-- Class representing a rich underground nutriment zone
------------------------------------------------------------------------

class "Nutriment"{
}

function Nutriment:__init__()
    self.x_pos, self.y_pos  =   0, 0
    local r                 =   math.random(50, 75)
    self.resource           =   {max=r, current=r}
    self.dead               =   false
    self.selected           =   false
    self.hovered            =   false

end

function Nutriment:setPosition(p_x, p_y)
    self.x_pos  =   p_x or 0
    self.y_pos  =   p_y or 0
    self.pos    =   {x=p_x, y=p_y}

end

function Nutriment:update(dt)
    if self.resource.current <= 0 then
        self.dead    =    false
    end

end

function Nutriment:draw()
    local ratio     =   self.resource.current / self.resource.max
    local color     =   255 - ratio * 255
    local size      =   self.resource.max * ratio
    love.graphics.setColor(255, color, color, 90)
    love.graphics.circle("fill", self.x_pos, self.y_pos, 5 )

    --~ if self.selected then
        --~ love.graphics.setColor(255, 155, 80, 255)
    --~ elseif self.hovered then
        --~ love.graphics.setColor(255, 255, 255, 125)
    --~ else
        --~ love.graphics.setColor(210, 105, 30, 255)
    --~ end
    --~ love.graphics.circle("fill", self.x_pos, self.y_pos, math.log(self.resource.current*2) )

end

function Nutriment:collect( dt )
    local delta = 1 * dt
    self.resource.current = self.resource.current - delta
    return delta

end
